blob: b557ba6db97e9b5c7d6af7a6175fe6a2599a462c [file] [log] [blame]
Test User01ed0642019-07-03 20:17:06 +00001#!/bin/bash
David K. Bainbridgeb7285432019-07-02 22:05:24 -07002# Copyright 2019 Ciena Corporation
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
David Bainbridge712afb82019-08-14 19:55:58 +000015TOTAL_START_TIME=$(date +%s)
David K. Bainbridgeb7285432019-07-02 22:05:24 -070016
David Bainbridge38dc1e82019-08-12 15:18:45 +000017FANCY=${FANCY:-1}
18if [ "$TERM X" == " X" ]; then
19 FANCY=0
20fi
21
David K. Bainbridgeb7285432019-07-02 22:05:24 -070022# trap ctrl-c and call ctrl_c()
23trap ctrl_c INT
24
25function ctrl_c() {
David Bainbridge38dc1e82019-08-12 15:18:45 +000026 echo -en $CNORM
David K. Bainbridgeb7285432019-07-02 22:05:24 -070027 echo ""
28 echo "ctrl-c trapped"
David Bainbridgec6a6eb62019-10-18 22:50:07 +000029 echo "Thank you for trying 'voltha up'"
David K. Bainbridgeb7285432019-07-02 22:05:24 -070030 exit
31}
32
David K. Bainbridgeebf38d92020-02-10 10:46:31 -080033VOLTCTL_VERSION=${VOLTCTL_VERSION:-latest}
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -080034KIND_VERSION=${KIND_VERSION:-v0.5.1}
David K. Bainbridgeb3a99372020-01-08 14:39:06 -080035VK_RELEASE=${VK_RELEASE:-master}
Test User08ebbd92019-07-03 17:15:39 +000036
David Bainbridge38dc1e82019-08-12 15:18:45 +000037BLACK=
38RED=
39GREEN=
40YELLOW=
41BLUE=
42MAGENTA=
43CYAN=
44WHITE=
45BOLD=
46NORMAL=
47ERROR=
48CEOL=
49CNORM=
50CIVIS=
51if [ $FANCY -eq 1 ]; then
52 BLACK=$(tput setaf 0)
53 RED=$(tput setaf 1)
54 GREEN=$(tput setaf 2)
55 YELLOW=$(tput setaf 3)
56 BLUE=$(tput setaf 4)
57 MAGENTA=$(tput setaf 5)
58 CYAN=$(tput setaf 6)
59 WHITE=$(tput setaf 7)
60 BOLD=$(tput bold)
61 NORMAL=$(tput sgr0)
62 ERROR="\xe2\x9c\x97\x20"
63 CEOL=$(tput el)
64 CNORM=$(tput cnorm)
65 CIVIS=$(tput civis)
66fi
Test User7d866122019-07-09 17:52:35 +000067
Test User3d7ad8e2019-07-03 06:15:44 +000068TYPE=${TYPE:-minimal}
David Bainbridge0774b232019-08-02 06:37:19 +000069NAME=${NAME:-$TYPE}
David Bainbridgee87067b2019-08-12 22:00:12 +000070WITH_TIMINGS=${WITH_TIMINGS:-no}
Test User7d866122019-07-09 17:52:35 +000071WITH_BBSIM=${WITH_BBSIM:-no}
David Bainbridge5b7b96b2019-07-25 20:29:13 +000072WITH_RADIUS=${WITH_RADIUS:-no}
Matteo Scandolo78dfee02020-02-13 16:18:03 -080073WITH_EAPOL=${WITH_EAPOL:-yes}
74WITH_DHCP=${WITH_DHCP:-yes}
75WITH_IGMP=${WITH_IGMP:-no}
David Bainbridgeb270c202019-07-26 01:44:42 +000076WITH_ONOS=${WITH_ONOS:-yes}
David Bainbridge99ac7a22019-08-31 02:26:43 +000077WITH_CHAOS=${WITH_CHAOS:-no}
David Bainbridge46505fb2019-10-01 21:13:20 +000078WITH_ADAPTERS=${WITH_ADAPTERS:-yes}
79WITH_SIM_ADAPTERS=${WITH_SIM_ADAPTERS:-yes}
80WITH_OPEN_ADAPTERS=${WITH_OPEN_ADAPTERS:-yes}
David Bainbridge05cd8822019-11-19 17:43:53 +000081ONLY_ONE=${ONLY_ONE:-yes}
David Bainbridge2b19e832019-08-16 02:40:53 +000082CONFIG_SADIS=${CONFIG_SADIS:-no}
David Bainbridge27790d62019-08-13 22:43:19 +000083INSTALL_ONOS_APPS=${INSTALL_ONOS_APPS:-no}
Test Userba1e7e72019-07-10 22:27:54 +000084JUST_K8S=${JUST_K8S:-no}
85DEPLOY_K8S=${DEPLOY_K8S:-yes}
David K. Bainbridge0e89cb92019-07-17 11:30:10 -070086INSTALL_KUBECTL=${INSTALL_KUBECTL:-yes}
87INSTALL_HELM=${INSTALL_HELM:-yes}
David Bainbridge46505fb2019-10-01 21:13:20 +000088UPDATE_HELM_REPOS=${UPDATE_HELM_REPOS:-yes}
Matteo Scandolofab98622020-01-28 15:17:20 -080089WAIT_ON_DOWN=${WAIT_ON_DOWN:-yes}
David Bainbridge5b7b96b2019-07-25 20:29:13 +000090VOLTHA_LOG_LEVEL=${VOLTHA_LOG_LEVEL:-WARN}
David Bainbridge90fd8e32019-08-21 23:32:47 +000091VOLTHA_CHART=${VOLTHA_CHART:-onf/voltha}
92VOLTHA_CHART_VERSION=${VOLTHA_CHART_VERSION:-latest}
93VOLTHA_BBSIM_CHART=${VOLTHA_BBSIM_CHART:-onf/bbsim}
Matteo Scandolodcd29f52019-10-07 15:42:42 -070094VOLTHA_BBSIM_CHART_VERSION=${VOLTHA_BBSIM_CHART_VERSION:-latest}
David Bainbridgee10f6d52019-07-25 00:28:13 +000095VOLTHA_ADAPTER_SIM_CHART=${VOLTHA_ADAPTER_SIM_CHART:-onf/voltha-adapter-simulated}
David Bainbridge90fd8e32019-08-21 23:32:47 +000096VOLTHA_ADAPTER_SIM_CHART_VERSION=${VOLTHA_ADAPTER_SIM_CHART_VERSION:-latest}
David Bainbridgee10f6d52019-07-25 00:28:13 +000097VOLTHA_ADAPTER_OPEN_OLT_CHART=${VOLTHA_ADAPTER_OPEN_OLT_CHART:-onf/voltha-adapter-openolt}
David Bainbridge90fd8e32019-08-21 23:32:47 +000098VOLTHA_ADAPTER_OPEN_OLT_CHART_VERSION=${VOLTHA_ADAPTER_OPEN_OLT_CHART_VERSION:-latest}
David Bainbridgee10f6d52019-07-25 00:28:13 +000099VOLTHA_ADAPTER_OPEN_ONU_CHART=${VOLTHA_ADAPTER_OPEN_ONU_CHART:-onf/voltha-adapter-openonu}
David Bainbridge90fd8e32019-08-21 23:32:47 +0000100VOLTHA_ADAPTER_OPEN_ONU_CHART_VERSION=${VOLTHA_ADAPTER_OPEN_ONU_CHART_VERSION:-latest}
Andrea Campanella21323292019-12-18 11:44:19 -0800101ONOS_CHART_VERSION=${ONOS_CHART_VERSION:-latest}
David Bainbridge70c0ea82019-11-14 23:25:26 +0000102EXTRA_HELM_INSTALL_ARGS=
uottrembb16d3982020-02-28 08:34:36 +0100103NUM_OF_BBSIM=${NUM_OF_BBSIM:-1}
104MAX_NUM_OF_BBSIM=10
Test Userba1e7e72019-07-10 22:27:54 +0000105
106HAVE_GO=$(which go >/dev/null 2>&1 && echo "yes" || echo "no")
107HOSTOS=$(uname -s | tr "[:upper:]" "[:lower:"])
108HOSTARCH=$(uname -m | tr "[:upper:]" "[:lower:"])
109if [ $HOSTARCH == "x86_64" ]; then
110 HOSTARCH="amd64"
111fi
Test User7d866122019-07-09 17:52:35 +0000112
uottrembb16d3982020-02-28 08:34:36 +0100113# check number (range) of bbsim, max bbsim must not exceed 10 instances!
114# note: instances will be numbered from 0 to 9
115if [ "$1" == "up" ]; then
116 if [ "$NUM_OF_BBSIM" -lt 1 ]; then
117 >&2 echo -e "${RED}${BOLD}${ERROR}ERROR:${NORMAL}${RED} Invalid setting of BBSIM instances. NUM_OF_BBSIM is less than 1${NORMAL}"
118 exit 1
119 fi
120 if [ "$NUM_OF_BBSIM" -gt $MAX_NUM_OF_BBSIM ]; then
121 >&2 echo -e "${RED}${BOLD}${ERROR}ERROR:${NORMAL}${RED} Invalid setting of BBSIM instances. NUM_OF_BBSIM is greater than $MAX_NUM_OF_BBSIM${NORMAL}"
122 exit 1
123 fi
124fi
Test User7d866122019-07-09 17:52:35 +0000125# Verify TYPE setting
126if [ $(echo ":minimal:full:" | grep -ic ":$TYPE:") -eq 0 ]; then
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700127 >&2 echo -e "${RED}${BOLD}${ERROR}ERROR:${NORMAL}${RED} Invalid \$TYPE value of '$TYPE'. Should be 'minimal' or 'full'${NORMAL}"
Test User7d866122019-07-09 17:52:35 +0000128 exit 1
129fi
130
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000131# Used to verify configuration values are set to "yes" or "no" value or convert
132# equivalents to "yes" or "no"
133function verify_yes_no() {
134 local VAR=$1
135 local VAL=$(eval echo \$$VAR)
136 if [ $(echo ":y:yes:true:n:no:false:1:0:" | grep -ic ":$VAL:") -eq 0 ]; then
137 >&2 echo -e "${RED}${BOLD}${ERROR}ERROR:${NORMAL}${RED} Invalid '$VAR' value of '$VAL'. Should be 'yes' or 'no'${NORMAL}"
138 echo "INVALID"
139 return 1
140 fi
141 if [ $(echo ":y:yes:true:1:" | grep -ic ":$VAL:") -eq 1 ]; then
142 echo "yes"
143 else
144 echo "no"
145 fi
146 return 0
147}
Test User7d866122019-07-09 17:52:35 +0000148
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000149ALL_YES_NO="\
150 WITH_TIMINGS \
151 WITH_BBSIM \
152 WITH_RADIUS \
Matteo Scandolo78dfee02020-02-13 16:18:03 -0800153 WITH_EAPOL \
154 WITH_DHCP \
155 WITH_IGMP \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000156 WITH_ONOS \
David Bainbridge99ac7a22019-08-31 02:26:43 +0000157 WITH_CHAOS \
David Bainbridge46505fb2019-10-01 21:13:20 +0000158 WITH_ADAPTERS \
159 WITH_SIM_ADAPTERS \
160 WITH_OPEN_ADAPTERS \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000161 CONFIG_SADIS \
162 JUST_K8S \
163 DEPLOY_K8S \
164 INSTALL_ONOS_APPS \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000165 INSTALL_KUBECTL \
166 INSTALL_HELM \
David Bainbridge46505fb2019-10-01 21:13:20 +0000167 UPDATE_HELM_REPOS \
David Bainbridge4f1b5562019-08-19 04:46:52 +0000168 WAIT_ON_DOWN \
David Bainbridge70c0ea82019-11-14 23:25:26 +0000169 ONLY_ONE \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000170 "
David Bainbridge5b7b96b2019-07-25 20:29:13 +0000171
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000172ALL_OPTIONS="\
173 NAME \
174 TYPE \
175 $ALL_YES_NO \
176 VOLTHA_LOG_LEVEL \
177 VOLTHA_CHART \
David Bainbridge90fd8e32019-08-21 23:32:47 +0000178 VOLTHA_CHART_VERSION \
179 VOLTHA_BBSIM_CHART \
180 VOLTHA_BBSIM_CHART_VERSION \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000181 VOLTHA_ADAPTER_SIM_CHART \
David Bainbridge90fd8e32019-08-21 23:32:47 +0000182 VOLTHA_ADAPTER_SIM_CHART_VERSION \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000183 VOLTHA_ADAPTER_OPEN_OLT_CHART \
David Bainbridge90fd8e32019-08-21 23:32:47 +0000184 VOLTHA_ADAPTER_OPEN_OLT_CHART_VERSION \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000185 VOLTHA_ADAPTER_OPEN_ONU_CHART \
David Bainbridge90fd8e32019-08-21 23:32:47 +0000186 VOLTHA_ADAPTER_OPEN_ONU_CHART_VERSION \
Andrea Campanella21323292019-12-18 11:44:19 -0800187 ONOS_CHART_VERSION \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000188 ONOS_API_PORT \
189 ONOS_SSH_PORT \
190 VOLTHA_API_PORT \
191 VOLTHA_SSH_PORT \
192 VOLTHA_ETCD_PORT \
David K. Bainbridge8f7f30b2020-01-08 13:06:16 -0800193 VK_RELEASE \
194 KIND_VERSION \
195 VOLTCTL_VERSION \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000196 "
David Bainbridge01294952019-07-30 19:33:45 +0000197
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000198# Iterate over yes/no configuration options and validate
199for VAR in $ALL_YES_NO; do
200 eval $VAR=$(verify_yes_no $VAR)
201 if [ "$(eval echo \$$VAR)" == "INVALID" ]; then
202 exit 1;
203 fi
204done
David Bainbridgeb270c202019-07-26 01:44:42 +0000205
David Bainbridge0774b232019-08-02 06:37:19 +0000206mkdir -p .voltha
207touch .voltha/ports
208HAVE=$(grep $NAME .voltha/ports)
209if [ "$HAVE X" == " X" ]; then
210 # Find free port prefix
211 START=81
212 while true; do
213 if [ $(grep -c $START .voltha/ports) -eq 0 ]; then
214 break
215 fi
216 START=$(expr $START + 1)
217 done
218 DELTA=$(expr $START - 81)
David Bainbridgea2595422019-10-22 03:54:28 +0000219 ONOS_API_PORT=${ONOS_API_PORT:-${START}81}
220 ONOS_SSH_PORT=${ONOS_SSH_PORT:-${START}01}
221 VOLTHA_API_PORT=${VOLTHA_API_PORT:-5$(expr 55 + $DELTA)55}
222 VOLTHA_SSH_PORT=${VOLTHA_SSH_PORT:-$(expr 50 + $DELTA)22}
223 VOLTHA_ETCD_PORT=${VOLTHA_ETCD_PORT:-$(expr 23 + $DELTA)79}
Test User01ed0642019-07-03 20:17:06 +0000224else
David Bainbridge0774b232019-08-02 06:37:19 +0000225 VALUES=$(echo $HAVE | sed -e 's/\s//g' | cut -d= -f2)
David Bainbridgea2595422019-10-22 03:54:28 +0000226 ONOS_API_PORT=${ONOS_API_PORT:-$(echo $VALUES | cut -d, -f1)}
227 ONOS_SSH_PORT=${ONOS_SSH_PORT:-$(echo $VALUES | cut -d, -f2)}
228 VOLTHA_API_PORT=${VOLTHA_API_PORT:-$(echo $VALUES | cut -d, -f3)}
229 VOLTHA_SSH_PORT=${VOLTHA_SSH_PORT:-$(echo $VALUES | cut -d, -f4)}
230 VOLTHA_ETCD_PORT=${VOLTHA_ETCD_PORT:-$(echo $VALUES | cut -d, -f5)}
Test User01ed0642019-07-03 20:17:06 +0000231fi
232
David Bainbridge0774b232019-08-02 06:37:19 +0000233PORTTMP=$(mktemp -u)
234cat .voltha/ports | grep -v $NAME > $PORTTMP
235echo "$NAME=$ONOS_API_PORT,$ONOS_SSH_PORT,$VOLTHA_API_PORT,$VOLTHA_SSH_PORT,$VOLTHA_ETCD_PORT" >> $PORTTMP
236cp $PORTTMP .voltha/ports
237rm -f $PORTTMP
238
David Bainbridge27790d62019-08-13 22:43:19 +0000239export ONOS_API_PORT ONOS_SSH_PORT
David Bainbridge01294952019-07-30 19:33:45 +0000240
Test Userd87942b2019-07-03 07:20:24 +0000241IDX=1
David Bainbridgee87067b2019-08-12 22:00:12 +0000242CLOCK="TIME:"
David Bainbridge38dc1e82019-08-12 15:18:45 +0000243SPIN_PARTS=
244NOT_VERIFIED=
David Bainbridgef858a022019-08-14 21:25:11 +0000245THEX=
246BUILD=
247CROSS=
248ENTER=
David Bainbridge38dc1e82019-08-12 15:18:45 +0000249VERIFIED=
250HELM=
251OLD_KEY=
252BIRD=
253HIGH_VOLTAGE=
254PLUG=
255RESTART=
256FORWARD=
257INSTALL=
258STOP=
259GO=
260DOWNLOAD=
261GEAR=
262NO_ENTRY=
263LOCK=
264
265if [ $FANCY -eq 1 ]; then
266 SPIN_PARTS="\
267 \xe2\xa2\x8e\xe2\xa1\xb0 \
268 \xe2\xa2\x8e\xe2\xa1\xa1 \
269 \xe2\xa2\x8e\xe2\xa1\x91 \
270 \xe2\xa2\x8e\xe2\xa0\xb1 \
271 \xe2\xa0\x8e\xe2\xa1\xb1 \
272 \xe2\xa2\x8a\xe2\xa1\xb1 \
273 \xe2\xa2\x8c\xe2\xa1\xb1 \
274 \xe2\xa2\x86\xe2\xa1\xb1 \
275 "
David Bainbridgee87067b2019-08-12 22:00:12 +0000276 CLOCK="\xe2\x8f\xb1"
David Bainbridgef858a022019-08-14 21:25:11 +0000277 THEX="${RED}${BOLD}\xe2\x9c\x97\x20${NORMAL}"
278 ENTER="${YELLOW}${BOLD}\xe2\x8e\x86${NORMAL}"
279 CROSS="${YELLOW}${BOLD}\xe2\x9c\x9a${NORMAL}"
280 BUILD="${YELLOW}${BOLD}\xf0\x9f\x8f\x97${NORMAL}"
281 NOT_VERIFIED="$BUILD"
282 VERIFIED="${GREEN}${BOLD}\xe2\x9c\x93\x20${NORMAL}"
283 HELM="${BLUE}${BOLD}\xE2\x8E\x88${NORMAL}"
David Bainbridge38dc1e82019-08-12 15:18:45 +0000284 OLD_KEY="\xF0\x9F\x97\x9D"
285 BIRD="\xF0\x9F\x90\xA6"
286 HIGH_VOLTAGE="\xE2\x9A\xA1"
287 PLUG="\xF0\x9F\xa7\xa9"
288 RESTART="\xf0\x9f\x94\x84"
289 FORWARD="\xE2\x87\xA8"
290 INSTALL="\xF0\x9F\x8F\x97"
291 STOP="\xf0\x9f\x9b\x91"
292 GO="\xf0\x9f\x9a\x80"
293 DOWNLOAD="\xf0\x9f\x93\xa5"
294 GEAR="\xe2\x9a\x99"
295 NO_ENTRY="\xe2\x9b\x94"
296 LOCK="\xf0\x9f\x94\x92"
297fi
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700298
David Bainbridge712afb82019-08-14 19:55:58 +0000299duration() {
David Bainbridgee87067b2019-08-12 22:00:12 +0000300 local h=$(expr $1 / 3600)
301 local m=$(expr $1 % 3600 / 60)
302 local s=$(expr $1 % 60)
303 local t=""
304
305 if [ $h -gt 0 ]; then
306 t="$t${h}h"
307 fi
308 if [ $m -gt 0 ]; then
309 t="$t${m}m"
310 fi
David Bainbridge712afb82019-08-14 19:55:58 +0000311 echo "$t${s}s"
312}
313
314printtime() {
315 local INDENT=
316 if [ "$1" == "-" ]; then
317 INDENT=" "
318 shift
319 fi
320 echo -e "$INDENT $CLOCK $(duration $1)"
David Bainbridgee87067b2019-08-12 22:00:12 +0000321}
322
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700323bspin() {
Test Userd87942b2019-07-03 07:20:24 +0000324 IDX=1
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700325 local INDENT=
326 if [ "$1" == "-" ]; then
327 INDENT=" "
328 shift
329 fi
David Bainbridge38dc1e82019-08-12 15:18:45 +0000330 if [ $FANCY -eq 0 ]; then
331 LINE=$(echo $* | sed -e 's/[\s+-]//g')
332 if [ "$LINE X" == " X" ]; then
333 return
334 fi
335 echo -e "$CIVIS$INDENT$*"
336 else
337 echo -en "$CIVIS$INDENT $*"
338 fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700339}
340
341sspin() {
342 local INDENT=
343 if [ "$1" == "-" ]; then
344 INDENT=" "
345 shift
346 fi
David Bainbridge38dc1e82019-08-12 15:18:45 +0000347 if [ $FANCY -eq 0 ]; then
348 LINE=$(echo $* | sed -e 's/[\s+-]//g')
349 if [ "$LINE X" == " X" ]; then
350 return
351 fi
352 echo -e "$INDENT$*"
353 else
354 C=$(echo $SPIN_PARTS | cut '-d ' -f $IDX)
355 echo -en "\r$INDENT$C $*"
356 IDX=$(expr $IDX + 1)
357 if [ $IDX -gt 8 ]; then
358 IDX=1
359 fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700360 fi
361}
362
363espin() {
364 local INDENT=
365 if [ "$1" == "-" ]; then
366 INDENT=" "
367 shift
368 fi
David Bainbridge38dc1e82019-08-12 15:18:45 +0000369 if [ $FANCY -eq 0 ]; then
370 LINE=$(echo $* | sed -e 's/[\s+-]//g')
371 if [ "$LINE X" == " X" ]; then
372 return
373 fi
374 echo -e "$INDENT$*"
375 else
376 echo -e "\r$INDENT$*$CNORM"
377 fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700378}
379
David Bainbridgeac7f8072019-08-01 22:15:33 +0000380if [ "$1" == "get" -a "$2" == "voltconfig" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000381 echo "$HOME/.volt/config-$NAME"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000382 exit
383fi
384
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700385if [ $# -ne 1 -o $(echo ":up:down:dump:" | grep -c ":$1:") -ne 1 ]; then
David Bainbridgeac7f8072019-08-01 22:15:33 +0000386 >&2 echo "What wouild you like to do today:"
387 >&2 echo " up - bring up voltha"
388 >&2 echo " down - tear down voltha"
389 >&2 echo " dump - create a debug dump of running system"
390 exit 1
391fi
392
David Bainbridge4f1b5562019-08-19 04:46:52 +0000393push_onos_config() {
Matteo Scandolo78dfee02020-02-13 16:18:03 -0800394 local TYPE=$1
395 local MSG=$2
396 local RESOURCE=$3
397 local DATA=$4
David Bainbridge4f1b5562019-08-19 04:46:52 +0000398
David K. Bainbridgeb4b163b2020-02-19 15:55:06 -0800399 # Thanks to the latest version of ONOS using the return code 207 this gets a
400 # whole lot nastier. Can't thank them enough for doing this. So in order to
401 # capture the command and the output in the log file as well as capture the
402 # status code to verify it is 200 and not 207 mutltiple files and a bit of
403 # hackery must be used. Thanks again ONOS.
404 local CMD_ECHO=$(mktemp -u)
405 local CMD_OUTPUT=$(mktemp -u)
406 local SC_OUTPUT=$(mktemp -u)
407
David Bainbridge4f1b5562019-08-19 04:46:52 +0000408 bspin - "$MSG $GEAR"
409 while true; do
Matteo Scandolo78dfee02020-02-13 16:18:03 -0800410 if [ $TYPE == "file" ]; then
David K. Bainbridgeb4b163b2020-02-19 15:55:06 -0800411 (set -x; curl --fail -sSL --user karaf:karaf -w "%{http_code}" -o $CMD_OUTPUT -X POST -H Content-Type:application/json http://127.0.0.1:$ONOS_API_PORT/onos/v1/$RESOURCE --data @$DATA >$SC_OUTPUT 2>/dev/null) >>$CMD_ECHO 2>&1
Matteo Scandolo78dfee02020-02-13 16:18:03 -0800412 fi
413 if [ $TYPE == "json" ]; then
David K. Bainbridgeb4b163b2020-02-19 15:55:06 -0800414 (set -x; curl --fail -sSL --user karaf:karaf -w "%{http_code}" -o $CMD_OUTPUT -X POST -H Content-Type:application/json http://127.0.0.1:$ONOS_API_PORT/onos/v1/$RESOURCE --data $DATA >$SC_OUTPUT 2>/dev/null) >>$CMD_ECHO 2>&1
Matteo Scandolo78dfee02020-02-13 16:18:03 -0800415 fi
David K. Bainbridgeb4b163b2020-02-19 15:55:06 -0800416 RESULT=$?
417 # Dump everything to the log
418 cat $CMD_ECHO >> $LOG
419 cat $CMD_OUTPUT >> $LOG
420 SC=$(cat $SC_OUTPUT)
421
422 # clean up temp files
423 rm -f $CMD_ECHO $CMD_OUTPUT $SC_OUTPUT
424 if [ $RESULT -eq 0 -a "$SC" == "200" ]; then
David Bainbridge4f1b5562019-08-19 04:46:52 +0000425 break
426 fi
Matteo Scandolo9a77a732020-01-09 14:24:12 -0800427 sleep 1
David Bainbridge4f1b5562019-08-19 04:46:52 +0000428 sspin -
429 done
430 espin - $VERIFIED
431}
432
Matteo Scandolo9a77a732020-01-09 14:24:12 -0800433check_onos_app_active() {
434 local APP_ID=$1
435
436 bspin - "Checking that $APP_ID is active $CLOCK"
437 while true; do
438 (set -x; curl --fail -sSL --user karaf:karaf -X GET http://127.0.0.1:$ONOS_API_PORT/onos/v1/applications/$APP_ID | grep ACTIVE >>$LOG 2>&1) >>$LOG 2>&1
439 if [ $? -eq 0 ]; then
440 break
441 fi
442 sleep 1
443 sspin -
444 done
445 sleep 5 # OSGI components take a little longer that the app to activate
446 espin - $VERIFIED
447}
448
David Bainbridge4f1b5562019-08-19 04:46:52 +0000449override_onos_app() {
450 local APP=$1
451 local NAME=$(basename $APP | sed -e 's/^[0-9][0-9]*-//g' -e 's/-.*$//g')
452 while true; do
453 sspin -
454 # Attempt to delete old version (if it exists)
455 (set -x; curl --fail -sSL --user karaf:karaf -X DELETE http://127.0.0.1:$ONOS_API_PORT/onos/v1/applications/$NAME >>$LOG 2>&1) >>$LOG 2>&1
456 sspin -
457 if [ $? -ne 0 ]; then
458 continue
459 fi
460 (set -x; curl --fail -sSL --user karaf:karaf -X POST -H Content-Type:application/octet-stream http://127.0.0.1:$ONOS_API_PORT/onos/v1/applications?activate=true --data-binary @$APP >>$LOG 2>&1) >>$LOG 2>&1
461 if [ $? -eq 0 ]; then
462 break
463 fi
464 sleep .2
465 done
466}
467
468activate_onos_app() {
469 local MSG="$1"
470 local APP=$2
471
472 bspin - "$MSG $GO"
473 while true; do
474 sspin -
475 (set -x; curl --fail -sSL --user karaf:karaf -X POST http://127.0.0.1:$ONOS_API_PORT/onos/v1/applications/$APP/active >>$LOG 2>&1) >>$LOG 2>&1
476 if [ $? -eq 0 ]; then
477 break
478 fi
479 sleep .2
480 done
481 espin - "$VERIFIED"
482}
483
484count_pods() {
485 local NAMESPACE=$1; shift
486 if [ "$NAMESPACE" == "all-namespaces" ]; then
487 NAMESPACE="--all-namespaces"
488 else
489 NAMESPACE="-n $NAMESPACE"
490 fi
491 echo "$NAMESPACE" > /tmp/t
492 local STATES=$1; shift
493 echo "$STATES" >> /tmp/t
494 local PODS=$(kubectl get $NAMESPACE pod -o go-template="{{range .items}}{{.metadata.name}}/{{.status.phase}}/_{{range .status.containerStatuses}}{{.ready}}_{{end}} {{end}}")
495 local COUNT=0
496 local PATTERNS="$*"
497 for POD in $PODS; do
498 local NAME=$(echo $POD | cut -d/ -f 1)
499 local STATE=$(echo $POD | cut -d/ -f 2)
500 local CONTAINERS=$(echo $POD | cut -d/ -f 3 | sed -e 's/_/ /g')
501 if [ "$STATES" == "*" -o $(echo "$STATES" | grep -c ":$STATE:") -ne 0 ]; then
502 echo "IN WITH $POD" >> /tmp/t
503 local TOTAL=$(echo $CONTAINERS | wc -w)
504 local FOUND=$(echo $CONTAINERS | grep -o true | wc -l)
505 if [ $TOTAL -eq $FOUND ]; then
506 for PATTERN in $PATTERNS; do
507 echo "TEST $PATTERN AGAINST $NAME" >> /tmp/t
508 if [[ $NAME =~ $PATTERN ]]; then
509 echo "COUNT $NAME" >> /tmp/t
510 COUNT=$(expr $COUNT + 1)
511 break
512 fi
513 done
514 fi
515 fi
516 done
517 echo $COUNT >> /tmp/t
518 echo $COUNT
519}
520
521wait_for_pods() {
522 local INDENT=
523 if [ "$1" == "-" ]; then
524 INDENT=$1; shift
525 fi
526 local NAMESPACE=$1; shift
527 local EXPECT=$1; shift
528 local TYPE=$1; shift
529 local RETRY=$1; shift
530 local MESSAGE=$1; shift
531 local PATTERNS=$*
David Bainbridge99ac7a22019-08-31 02:26:43 +0000532 local STATES=":Running:"
533 if [ "$TYPE" == "not" ]; then
534 STATES="*"
535 fi
536 local HAVE=$(count_pods $NAMESPACE "$STATES" $PATTERNS)
David Bainbridge4f1b5562019-08-19 04:46:52 +0000537 local ALL=$HAVE
538 if [ "$TYPE" == "only" ]; then
539 ALL=$(count_pods "all-namespaces" "*" ".*")
540 fi
541 COUNT=$(expr 300 / 15)
542 bspin $INDENT $MESSAGE
543 sspin $INDENT
544 if [ $HAVE -ne $EXPECT -o $ALL -ne $HAVE ]; then
545 while [ $HAVE -ne $EXPECT -o $ALL -ne $HAVE ]; do
546 sspin $INDENT
547 COUNT=$(expr $COUNT - 1)
548 if [ $COUNT -eq 0 ]; then
David Bainbridge99ac7a22019-08-31 02:26:43 +0000549 HAVE=$(count_pods $NAMESPACE "$STATES" $PATTERNS)
David Bainbridge4f1b5562019-08-19 04:46:52 +0000550 ALL=$HAVE
551 if [ "$TYPE" == "only" ]; then
552 ALL=$(count_pods "all-namespaces" "*" ".*")
553 fi
554 COUNT=$(expr 300 / 15)
555 fi
556 sleep .15
557 done
558 fi
559 espin $INDENT $VERIFIED
560 if [ $HAVE -ne $EXPECT ]; then
561 return 1
562 fi
563 return 0
564}
565
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800566port_forward() {
567 local NS=$1
568 local SVC=$2
569 local FROM_PORT=$3
570 local TO_PORT=$4
571 local TAG=$SVC-$NAME
572
573 (set -x; _TAG=$TAG bash -c "while true; do kubectl port-forward -n $NS service/$SVC $FROM_PORT:$TO_PORT; done" >>$LOG 2>&1 &) >>$LOG 2>&1
574}
575
576kill_port_forward() {
577 local TAG=$1-$NAME
David Bainbridgec6871d22019-11-13 17:10:31 +0000578 local P_IDS=$(ps e -ww -A | grep "_TAG=$TAG" | grep -v grep | awk '{print $1}')
David Bainbridgebcf235b2019-11-12 21:33:58 +0000579 local PARENTS=
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800580 local KIDS=
David Bainbridgec6871d22019-11-13 17:10:31 +0000581 local UNKNOWN=
582 if [ ! -z "$P_IDS" ]; then
583 for P_ID in $P_IDS; do
584 local PP_ID=$(ps -o ppid $P_ID | tail -n +2)
585 if [ ! -z "$PP_ID" ]; then
586 if [ $PP_ID -eq 1 ]; then
587 PARENTS="$PARENTS $P_ID"
588 else
589 KIDS="$KIDS $P_ID"
590 fi
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800591 else
David Bainbridgec6871d22019-11-13 17:10:31 +0000592 UNKNOWN="$UNKNOWN $P_ID"
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800593 fi
594 done
David Bainbridgec6871d22019-11-13 17:10:31 +0000595 (set -x; kill -9 $PARENTS $KIDS $UNKNOWN >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800596 fi
597}
598
David Bainbridgeac7f8072019-08-01 22:15:33 +0000599if [ "$1" == "down" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000600 echo "Tearing down voltha cluster $NAME"
601 LOG="down-$NAME.log"
602 echo $(date -u +"%Y%m%dT%H%M%SZ") >$LOG
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800603 bspin "Remove port-forwards: onos-ui-$NAME"
604 kill_port_forward onos-ui
605 sspin "Remove port-forwards: onos-ssh-$NAME$CEOL"
606 kill_port_forward onos-ssh
607 sspin "Remove port-forwards: voltha-api-$NAME$CEOL"
608 kill_port_forward voltha-api
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800609 sspin "Remove port-forwards: voltha-etcd-$NAME$CEOL"
610 kill_port_forward voltha-etcd-cluster-client
611 espin "$VERIFIED Remove port-forwards$CEOL"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000612 if [ $DEPLOY_K8S == "yes" ]; then
613 if [ -x ./bin/kind ]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000614 bspin "Delete Kubernetes Kind Cluster"
615 (set -x; ./bin/kind delete cluster --name voltha-$NAME >>$LOG 2>&1) >>$LOG 2>&1
616 espin $VERIFIED
David Bainbridgeac7f8072019-08-01 22:15:33 +0000617 else
David Bainbridge0774b232019-08-02 06:37:19 +0000618 espin "$NO_ENTRY Delete Kubernetes Kind Cluster: kind command not found"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000619 fi
620 else
621 EXISTS=$(helm list -q)
622 EXPECT="etcd-operator onos open-olt open-onu sim voltha bbsim radius"
David Bainbridge0774b232019-08-02 06:37:19 +0000623 bspin "Remove Helm Deployments"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000624 for i in $EXISTS; do
uottrembb16d3982020-02-28 08:34:36 +0100625 for j in $EXPECT; do
626 if [[ $i =~ $j ]]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000627 sspin "Remove Helm Deployments: $i$CEOL"
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800628 (set -x; ./bin/helm delete --no-hooks --purge $i >>$LOG 2>&1) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000629 fi
630 done
uottrembb16d3982020-02-28 08:34:36 +0100631 done
David Bainbridge0774b232019-08-02 06:37:19 +0000632 espin "$VERIFIED Remove Helm Deployments$CEOL"
David Bainbridge4f1b5562019-08-19 04:46:52 +0000633 if [ "$WAIT_ON_DOWN" == "yes" ]; then
634 # There should only be 13 or 15 PODs in the kube-system name
635 # space and no other PODs
David Bainbridge4f1b5562019-08-19 04:46:52 +0000636 PODS="coredns-.* \
637 etcd-voltha-$NAME-control-plane \
638 kindnet-.* \
639 kube-apiserver-voltha-$NAME-control-plane \
640 kube-controller-manager-voltha-$NAME-control-plane \
641 kube-proxy-.* \
642 kube-scheduler-voltha-$NAME-control-plane \
643 tiller-deploy-.*"
644 EXPECT=$(test "$TYPE" == "minimal" && echo "13" || echo "15")
David Bainbridge99ac7a22019-08-31 02:26:43 +0000645 PODS="adapter-.* \
646 bbsim.* \
647 etcd-operator.* \
648 radius.* \
649 voltha-.*"
Matteo Scandolo73442f92020-01-29 09:53:22 -0800650
David Bainbridge99ac7a22019-08-31 02:26:43 +0000651 EXPECT=0
652
Matteo Scandolo73442f92020-01-29 09:53:22 -0800653 if [ "$WITH_ONOS" == "yes" ]; then
654 ONOS_PODS="onos-.*"
655 wait_for_pods "default" $EXPECT "not" -1 "Waiting for ONOS PODs to terminate" $ONOS_PODS
656 fi
David Bainbridge99ac7a22019-08-31 02:26:43 +0000657 wait_for_pods "voltha" $EXPECT "not" -1 "Waiting for VOLTHA PODs to terminate" $PODS
David Bainbridge4f1b5562019-08-19 04:46:52 +0000658 fi
David Bainbridgeac7f8072019-08-01 22:15:33 +0000659 fi
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700660 exit
David Bainbridgeac7f8072019-08-01 22:15:33 +0000661fi
662
663if [ "$1" == "dump" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000664 LOG="dump-$NAME.log"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000665 TS=$(date -u +"%Y%m%dT%H%M%SZ")
David Bainbridge76514a02019-10-08 01:50:35 +0000666 if [ ! -z "$DUMP_FROM" ]; then
667 TS=$(echo $DUMP_FROM | sed -e 's/[:-]//g')
668 fi
David Bainbridgeac7f8072019-08-01 22:15:33 +0000669 WORK=$(mktemp -u -d)
David Bainbridge0774b232019-08-02 06:37:19 +0000670 DATA=$WORK/voltha-debug-dump-$NAME-$TS
David Bainbridgeac7f8072019-08-01 22:15:33 +0000671 mkdir -p $DATA
672 echo $TS > $LOG
David Bainbridge0774b232019-08-02 06:37:19 +0000673 echo -e "Capturing debug dump to voltha-debug-dump-$NAME-$TS.tgz"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000674 bspin - "Copy install log"
David Bainbridge0774b232019-08-02 06:37:19 +0000675 if [ -f install-$NAME.log ]; then
676 (set -x; cp install-$NAME.log $DATA/install-$NAME.log) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000677 espin - $VERIFIED
678 else
David Bainbridge0774b232019-08-02 06:37:19 +0000679 espin - "$NO_ENTRY Copy install log: install-$NAME.log not found"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000680 fi
681 bspin - "Dumping Kubernetes PODs"
682 (set -x; kubectl get --all-namespaces pods >> $DATA/all-pods.txt 2>&1) >>$LOG 2>&1
683 espin - $VERIFIED
684 bspin - "Dumping Kubernetes SERVICEs"
685 (set -x; kubectl get --all-namespaces svc >> $DATA/all-services.txt 2>&1) >>$LOG 2>&1
686 espin - $VERIFIED
687 bspin - "Dumping Kubernetes EVENTs"
688 (set -x; kubectl get --all-namespaces events >> $DATA/all-events.txt 2>&1) >>$LOG 2>&1
689 espin - $VERIFIED
690 bspin - "Dumping VOLTHA POD details"
Matteo Scandolodcd29f52019-10-07 15:42:42 -0700691 PODS="$(kubectl -n default get pod -o name | grep onos | sed -e 's/^/default:/g') $(kubectl get -n voltha pod -o name | sed -e 's/^/voltha:/g')"
David Bainbridgecfd7ca12019-10-06 03:31:41 +0000692 SINCE=
693 if [ ! -z "$DUMP_FROM" ]; then
694 SINCE="--since-time=$DUMP_FROM"
695 fi
David Bainbridgeac7f8072019-08-01 22:15:33 +0000696 for POD in $PODS; do
David Bainbridge1f0655a2019-10-01 22:08:48 +0000697 NS=$(echo $POD | cut -d: -f1)
698 POD=$(echo $POD | cut -d: -f2)
David Bainbridgeac7f8072019-08-01 22:15:33 +0000699 sspin - "Dumping VOLTHA POD details: $POD$CEOL"
700 mkdir -p $DATA/$POD
David Bainbridge1f0655a2019-10-01 22:08:48 +0000701 (set -x; kubectl describe -n $NS $POD >> $DATA/$POD/describe.txt 2>&1) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000702 sspin - "Dumping VOLTHA POD details: $POD"
David Bainbridgecfd7ca12019-10-06 03:31:41 +0000703 (set -x; kubectl logs -n $NS --all-containers $SINCE --previous $LOG_ARGS $POD >> $DATA/$POD/logs-previous.txt 2>&1) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000704 sspin - "Dumping VOLTHA POD details: $POD"
David Bainbridgecfd7ca12019-10-06 03:31:41 +0000705 (set -x; kubectl logs -n $NS --all-containers $SINCE $LOG_ARGS $POD >> $DATA/$POD/logs-current.txt 2>&1) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000706 sspin - "Dumping VOLTHA POD details: $POD"
707 done
708 espin - "$VERIFIED Dumping VOLTHA POD details$CEOL"
709 bspin - "Dumping ETCD"
710 if [ "$(which etcdctl) X" != " X" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000711 (set -x; ETCDCTL_API=3 etcdctl --endpoints localhost:$VOLTHA_ETCD_PORT get --prefix service/voltha | hexdump -C >> $DATA/etcd.hex 2>&1) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000712 espin - $VERIFIED
713 else
714 espin - "$NO_ENTRY Dumping ETCD: etcdctl command not available"
715 fi
David Bainbridge0774b232019-08-02 06:37:19 +0000716 bspin - "Creating compressed TAR: voltha-debug-dump-$NAME-$TS.tgz"
717 (set -x; tar -C $WORK -zcf voltha-debug-dump-$NAME-$TS.tgz ./voltha-debug-dump-$NAME-$TS) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000718 espin - $VERIFIED
719 bspin - "Cleanup"
720 (set -x; rm -rf $WORK) >>$LOG 2>&1
721 espin - $VERIFIED
David Bainbridge0774b232019-08-02 06:37:19 +0000722 bspin - "$(ls -l voltha-debug-dump-$NAME-$TS.tgz)"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000723 espin - $VERIFIED
724 exit
725fi
726
David Bainbridge0774b232019-08-02 06:37:19 +0000727LOG="install-$NAME.log"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000728date > $LOG
David Bainbridge0774b232019-08-02 06:37:19 +0000729echo "PORTS=$ONOS_API_PORT,$ONOS_SSH_PORT,$VOLTHA_API_PORT,$VOLTHA_SSH_PORT,$VOLTHA_ETCD_PORT" >> $LOG
David Bainbridgeac7f8072019-08-01 22:15:33 +0000730
731# Output install options to log
732echo "OPTIONS" >> $LOG
David Bainbridgeac7f8072019-08-01 22:15:33 +0000733for O in $ALL_OPTIONS; do
734 VAL=$(eval echo \$$O)
David Bainbridgeac7f8072019-08-01 22:15:33 +0000735 if [ ! -z "$VAL" ]; then
736 printf " %-30s = %s\n" $O $VAL >> $LOG
737 fi
738done
739
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700740helm_install() {
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700741 local INDENT=
742 if [ "$1" == "-" ]; then
743 INDENT=$1; shift
744 fi
745 local NAMESPACE=$1; shift
David Bainbridge0774b232019-08-02 06:37:19 +0000746 local INAME=$1; shift
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700747 local CHART=$1; shift
David Bainbridge90fd8e32019-08-21 23:32:47 +0000748 local CHART_VERSION=$1; shift
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700749 local MESSAGE=$*
750
David Bainbridge90fd8e32019-08-21 23:32:47 +0000751 if [ "$CHART_VERSION X" != " X" -a "$CHART_VERSION" != "latest" ]; then
752 CHART_VERSION="--version $CHART_VERSION"
753 else
754 CHART_VERSION=
755 fi
756
David Bainbridge99ac7a22019-08-31 02:26:43 +0000757 local CHART_ARGS=
758 if [ -r "${INAME}-values.yaml" ]; then
759 CHART_ARGS="-f ${INAME}-values.yaml"
760 fi
761
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700762 COUNT=$(expr 300 / 15)
763 bspin $INDENT $MESSAGE
David Bainbridge70c0ea82019-11-14 23:25:26 +0000764 (set -x; helm install -f $NAME-values.yaml $CHART_ARGS $EXTRA_HELM_INSTALL_ARGS --set defaults.log_level=$VOLTHA_LOG_LEVEL --namespace $NAMESPACE --name $INAME $CHART_VERSION $EXTRA_HELM_FLAGS $CHART >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700765 SUCCESS=$?
766 while [ $SUCCESS -ne 0 ]; do
767 sspin $INDENT
768 COUNT=$(expr $COUNT - 1)
769 if [ $COUNT -eq 0 ]; then
Andy Baviere22ff252019-12-19 11:40:31 -0700770 (set -x; helm delete --purge $INAME >>$LOG 2>&1) >>$LOG 2>&1
David Bainbridge99ac7a22019-08-31 02:26:43 +0000771 (set -x; helm install -f $NAME-values.yaml $CHART_ARGS --set defaults.log_level=$VOLTHA_LOG_LEVEL --namespace $NAMESPACE --name $INAME $CHART_VERSION $EXTRA_HELM_FLAGS $CHART >>$LOG 2>&1) >>$LOG 2>&1
Andy Baviere22ff252019-12-19 11:40:31 -0700772 SUCCESS=$?
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700773 COUNT=$(expr 300 / 15)
774 fi
775 sleep .15
776 done
777 espin $INDENT $VERIFIED
778}
779
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700780echo "INSTALL TYPE: $TYPE" >> $LOG
781
782bspin "Verify GOPATH"
783export GOPATH=$(pwd)
Test User3d7ad8e2019-07-03 06:15:44 +0000784mkdir -p $GOPATH/bin
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700785espin $VERIFIED
786
David Bainbridgee87067b2019-08-12 22:00:12 +0000787STIME=$(date +%s)
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700788if [ "$INSTALL_KUBECTL" == "no" ]; then
789 bspin "Skip kubectl install"
790 espin $NO_ENTRY
Test Userc13bdc92019-07-03 20:57:49 +0000791else
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700792 bspin "Verify kubectl $HELM"
793 if [ -x $GOPATH/bin/kubectl ]; then
794 espin $VERIFIED
795 else
796 espin $NOT_VERIFIED
797 bspin - "Download and install Kubernetes/kubectl $DOWNLOAD"
798 (set -x; curl -o $GOPATH/bin/kubectl -sSL https://storage.googleapis.com/kubernetes-release/release/$(curl -s https://storage.googleapis.com/kubernetes-release/release/stable.txt)/bin/$HOSTOS/$HOSTARCH/kubectl >>$LOG 2>&1) >>$LOG 2>&1
799 (set -x; chmod 755 $GOPATH/bin/kubectl >>$LOG 2>&1) >>$LOG 2>&1
800 espin - $VERIFIED
801 fi
Test Userc13bdc92019-07-03 20:57:49 +0000802fi
David Bainbridgee87067b2019-08-12 22:00:12 +0000803if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +0000804 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +0000805fi
Test Userc13bdc92019-07-03 20:57:49 +0000806
David Bainbridgee87067b2019-08-12 22:00:12 +0000807STIME=$(date +%s)
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700808if [ "$DEPLOY_K8S" == "no" ]; then
809 bspin "Skip Kubernetes/Kind Deployment"
810 espin $NO_ENTRY
811else
Test Userba1e7e72019-07-10 22:27:54 +0000812 bspin "Verify Kubernetes/Kind $HELM"
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800813 IS_INSTALLED=0
814 OP_TYPE="install"
Test Userba1e7e72019-07-10 22:27:54 +0000815 if [ -x $GOPATH/bin/kind ]; then
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800816 OP_TYPE="upgrade"
817 if [ $($GOPATH/bin/kind --version | grep -c $KIND_VERSION) -eq 1 ]; then
818 IS_INSTALLED=1
819 espin $VERIFIED
820 fi
821 fi
822 if [ $IS_INSTALLED -eq 0 ]; then
Test Userba1e7e72019-07-10 22:27:54 +0000823 espin $NOT_VERIFIED
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800824 bspin - "Download and $OP_TYPE Kubernetes/kind $DOWNLOAD"
David Bainbridge9e2a6662019-07-11 17:07:57 +0000825 (set -x; curl -o $GOPATH/bin/kind -sSL https://github.com/kubernetes-sigs/kind/releases/download/$KIND_VERSION/kind-$HOSTOS-$HOSTARCH >>$LOG 2>&1) >>$LOG 2>&1
Test Userba1e7e72019-07-10 22:27:54 +0000826 (set -x; chmod 755 $GOPATH/bin/kind >>$LOG 2>&1) >>$LOG 2>&1
827 espin - $VERIFIED
828 fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700829fi
830
David Bainbridgee87067b2019-08-12 22:00:12 +0000831if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +0000832 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +0000833fi
834
835STIME=$(date +%s)
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700836if [ "$INSTALL_HELM" == "no" ]; then
837 bspin "Skip Helm Install"
838 espin $NO_ENTRY
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700839else
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700840 bspin "Verify Helm $HELM"
841 if [ -x $GOPATH/bin/helm ]; then
842 espin $VERIFIED
843 else
844 espin $NOT_VERIFIED
845 bspin - "Download and install Helm $DOWNLOAD"
David Bainbridgec6a6eb62019-10-18 22:50:07 +0000846 (set -x; curl -sSL https://git.io/get_helm.sh | DESIRED_VERSION=v2.14.3 USE_SUDO=false HELM_INSTALL_DIR=$GOPATH/bin bash >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700847 espin - $VERIFIED
848 fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700849fi
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800850
David Bainbridgee87067b2019-08-12 22:00:12 +0000851if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +0000852 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +0000853fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700854
David Bainbridgee87067b2019-08-12 22:00:12 +0000855STIME=$(date +%s)
Test Userb5712372019-07-03 21:52:17 +0000856bspin "Verify voltctl $HIGH_VOLTAGE"
David Bainbridged2811972019-12-14 01:14:09 +0000857VOK=0
858VMESSAGE="install"
David K. Bainbridgeebf38d92020-02-10 10:46:31 -0800859export VC_VERSION="$VOLTCTL_VERSION"
860if [ "$VC_VERSION" == "latest" ]; then
861 export VC_VERSION=$(curl -sSL https://api.github.com/repos/opencord/voltctl/releases/latest | jq -r .tag_name | sed -e 's/^v//g')
862fi
Test User3d7ad8e2019-07-03 06:15:44 +0000863if [ -x $GOPATH/bin/voltctl ]; then
David Bainbridge1ba64f12019-12-18 00:40:13 +0000864 VHAVE=$($GOPATH/bin/voltctl version --clientonly -o json | jq -r .version)
David K. Bainbridgeebf38d92020-02-10 10:46:31 -0800865 if [ $? -eq 0 -a "$VHAVE" == "$VC_VERSION" ]; then
David Bainbridged2811972019-12-14 01:14:09 +0000866 VOK=1
David Bainbridge1ba64f12019-12-18 00:40:13 +0000867 espin $VERIFIED
868 else
David K. Bainbridgeebf38d92020-02-10 10:46:31 -0800869 VCHECK=$(echo -e "$VHAVE\n$VC_VERSION" | sort -V | head -1)
870 if [ "$VCHECK" == "$VHAVE" ]; then
871 VMESSAGE="upgrade"
872 else
873 VMESSAGE="downgrade"
874 fi
David Bainbridged2811972019-12-14 01:14:09 +0000875 fi
876fi
877
David Bainbridge1ba64f12019-12-18 00:40:13 +0000878if [ $VOK -eq 0 ]; then
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700879 espin $NOT_VERIFIED
David Bainbridged2811972019-12-14 01:14:09 +0000880 bspin - "Download and $VMESSAGE voltctl $DOWNLOAD"
David K. Bainbridgeebf38d92020-02-10 10:46:31 -0800881 (set -x; curl -o $GOPATH/bin/voltctl -sSL https://github.com/opencord/voltctl/releases/download/v$VC_VERSION/voltctl-$VC_VERSION-$HOSTOS-$HOSTARCH >>$LOG 2>&1) >>$LOG 2>&1
Test User08ebbd92019-07-03 17:15:39 +0000882 (set -x; chmod 755 $GOPATH/bin/voltctl >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700883 espin - $VERIFIED
884fi
David Bainbridgee87067b2019-08-12 22:00:12 +0000885if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +0000886 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +0000887fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700888
889bspin "Verify command PATH"
Test Userba1e7e72019-07-10 22:27:54 +0000890export PATH=$GOPATH/bin:$PATH
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700891espin $VERIFIED
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700892
David Bainbridgee87067b2019-08-12 22:00:12 +0000893STIME=$(date +%s)
Test Userba1e7e72019-07-10 22:27:54 +0000894if [ "$DEPLOY_K8S" == "yes" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000895 HAVE=$(kind get clusters | grep -c voltha-$NAME)
Test Userba1e7e72019-07-10 22:27:54 +0000896 bspin "Verify Kubernetes/Kind Cluster"
897 sspin
898 if [ $HAVE -eq 0 ]; then
David Bainbridge491b1bd2019-07-11 17:53:11 +0000899 espin $NOT_VERIFIED
900 bspin - "Verify cluster configuration"
David Bainbridge0774b232019-08-02 06:37:19 +0000901 if [ ! -r ./$NAME-cluster.cfg ]; then
David Bainbridge491b1bd2019-07-11 17:53:11 +0000902 espin - $NOT_VERIFIED
David Bainbridge0774b232019-08-02 06:37:19 +0000903 bspin - "Download cluster configuration: $TYPE-cluster.cfg to $NAME-cluster.cfg $DOWNLOAD"
David K. Bainbridgea00736b2020-01-08 14:33:17 -0800904 ERR_OUT=$(mktemp)
905 (set -x; curl --fail -o ./$NAME-cluster.cfg -sSL https://raw.githubusercontent.com/ciena/kind-voltha/$VK_RELEASE/$TYPE-cluster.cfg >>$LOG 2>>$ERR_OUT) >>$LOG 2>&1
906 if [ $? -ne 0 ]; then
907 espin - $THEX
908 echo -e "${RED}${BOLD}${ERROR}ERROR: $NAME-cluster.cfg${NORMAL}${RED} - $(cat $ERR_OUT)${NORMAL}"
909 echo "ERROR: $(cat $ERR_OUT)" >>$LOG
910 rm -rf $ERR_OUT ./$NAME-cluster.cfg
911 exit 1
912 fi
913 rm -rf $ERR_OUT
914 else
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700915 espin - $VERIFIED
David K. Bainbridgea00736b2020-01-08 14:33:17 -0800916 fi
David Bainbridge0774b232019-08-02 06:37:19 +0000917 kind create cluster --name voltha-$NAME --config $NAME-cluster.cfg
David Bainbridge491b1bd2019-07-11 17:53:11 +0000918 else
919 espin $VERIFIED
Test Userba1e7e72019-07-10 22:27:54 +0000920 fi
921
David Bainbridge0774b232019-08-02 06:37:19 +0000922 export KUBECONFIG="$(kind get kubeconfig-path --name="voltha-$NAME")"
Test Userba1e7e72019-07-10 22:27:54 +0000923 P="coredns-.* \
David Bainbridge0774b232019-08-02 06:37:19 +0000924 etcd-voltha-$NAME-control-plane \
Test Userba1e7e72019-07-10 22:27:54 +0000925 kindnet-.* \
David Bainbridge0774b232019-08-02 06:37:19 +0000926 kube-apiserver-voltha-$NAME-control-plane \
927 kube-controller-manager-voltha-$NAME-control-plane \
Test Userba1e7e72019-07-10 22:27:54 +0000928 kube-proxy-.* \
David Bainbridge0774b232019-08-02 06:37:19 +0000929 kube-scheduler-voltha-$NAME-control-plane"
Test Userba1e7e72019-07-10 22:27:54 +0000930
931 EXPECT=$(test "$TYPE" == "minimal" && echo "12" || echo "14")
David Bainbridge4f1b5562019-08-19 04:46:52 +0000932 wait_for_pods - "kube-system" $EXPECT "includes" -1 "Waiting for system PODs to start" $P
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700933fi
David Bainbridgee87067b2019-08-12 22:00:12 +0000934if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +0000935 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +0000936fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700937
David Bainbridgee87067b2019-08-12 22:00:12 +0000938STIME=$(date +%s)
David Bainbridge4c6289c2019-09-03 21:11:32 +0000939COUNT=$(count_pods "kube-system" ":Running:" "tiller-deploy-.*")
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700940bspin "Verify Helm"
Test Userba1e7e72019-07-10 22:27:54 +0000941if [ $COUNT -ne 1 ]; then
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700942 espin $NOT_VERIFIED
Test Userb5712372019-07-03 21:52:17 +0000943 echo -e "Configuring Helm $GEAR"
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700944 if [ "$INSTALL_HELM" == "no" ]; then
945 bspin - "Skip Helm/Tiller Initialization"
946 espin - $NO_ENTRY
947 else
948 bspin - "Initialize Helm"
949 (set -x; helm init --upgrade >>$LOG 2>&1) >>$LOG 2>&1
950 espin - $VERIFIED
David Bainbridge4f1b5562019-08-19 04:46:52 +0000951 wait_for_pods - "kube-system" 1 "includes" -1 "Waiting for Tiller POD to start" "tiller-deploy-.*"
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700952 fi
Test Userb5712372019-07-03 21:52:17 +0000953 bspin - "Add Google Incubator repository to Helm"
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700954 (set -x; helm repo add incubator https://kubernetes-charts-incubator.storage.googleapis.com >>$LOG 2>&1) >>$LOG 2>&1
955 espin - $VERIFIED
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700956
Test Userba1e7e72019-07-10 22:27:54 +0000957 # HACK (sort-of) - the config for tiller is about to be patched, which will
958 # cause the tiller pod to be recreated. This can sometimes cause a timing
959 # issue with the "wait_for_pods" call on tiller as it may incorrectly
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700960 # identify the running/ready tiller pod that is soon to be terminated as
Test Userba1e7e72019-07-10 22:27:54 +0000961 # what it is waiting for. To avoid this issue we do a clean scale down and
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700962 # scale up of the pod so the script controlls when it should be expecting
Test Userba1e7e72019-07-10 22:27:54 +0000963 # things
964 (set -x; kubectl -n kube-system scale deploy tiller-deploy --replicas=0 >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700965
Test Userb5712372019-07-03 21:52:17 +0000966 bspin - "Add Google Stable repository to Helm"
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700967 (set -x; helm repo add stable https://kubernetes-charts.storage.googleapis.com >>$LOG 2>&1) >>$LOG 2>&1
968 espin - $VERIFIED
Test Userb5712372019-07-03 21:52:17 +0000969 bspin - "Add ONF repository to Helm"
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700970 (set -x; helm repo add onf https://charts.opencord.org >>$LOG 2>&1) >>$LOG 2>&1
971 espin - $VERIFIED
Test Userb5712372019-07-03 21:52:17 +0000972 bspin - "Update Helm repository cache"
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700973 (set -x; helm repo update >>$LOG 2>&1) >>$LOG 2>&1
974 espin - $VERIFIED
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700975
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700976 # Create and k8s service account so that Helm can create pods
Test Userb5712372019-07-03 21:52:17 +0000977 bspin - "Create Tiller ServiceAccount"
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700978 (set -x; kubectl create serviceaccount --namespace kube-system tiller >>$LOG 2>&1) >>$LOG 2>&1
979 espin - $VERIFIED
Test Userb5712372019-07-03 21:52:17 +0000980 bspin - "Create Tiller ClusterRoleBinding"
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700981 (set -x; kubectl create clusterrolebinding tiller-cluster-rule --clusterrole=cluster-admin --serviceaccount=kube-system:tiller >>$LOG 2>&1) >>$LOG 2>&1
982 espin - $VERIFIED
Test Userb5712372019-07-03 21:52:17 +0000983 bspin - "Update Tiller Manifest"
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700984 (set -x; kubectl patch deploy --namespace kube-system tiller-deploy -p '{"spec":{"template":{"spec":{"serviceAccount":"tiller"}}}}' >>$LOG 2>&1) >>$LOG 2>&1
Test Userba1e7e72019-07-10 22:27:54 +0000985
986 # HACK (sort-of) - part to, spin it back up
987 (set -x; kubectl -n kube-system scale deploy tiller-deploy --replicas=1 >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700988 espin - $VERIFIED
989else
990 espin $VERIFIED
David Bainbridge46505fb2019-10-01 21:13:20 +0000991 if [ "$UPDATE_HELM_REPOS" == "yes" ]; then
992 bspin - "Update Helm repository cache"
993 (set -x; helm repo update >>$LOG 2>&1) >>$LOG 2>&1
994 espin - $VERIFIED
995 fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700996fi
David Bainbridge4f1b5562019-08-19 04:46:52 +0000997wait_for_pods - "kube-system" 1 "includes" -1 "Waiting for Tiller POD to start" "tiller-deploy-.*"
David Bainbridgee87067b2019-08-12 22:00:12 +0000998if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +0000999 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001000fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001001
David Bainbridgee87067b2019-08-12 22:00:12 +00001002STIME=$(date +%s)
David Bainbridge0774b232019-08-02 06:37:19 +00001003bspin "Verify Helm values file: $NAME-values.yaml"
1004if [ ! -r "./$NAME-values.yaml" ]; then
Test Userba1e7e72019-07-10 22:27:54 +00001005 espin $NOT_VERIFIED
David Bainbridge0774b232019-08-02 06:37:19 +00001006 bspin - "Download Helm values file: $TYPE-values.yaml to $NAME-values.yaml $DOWNLOAD"
David K. Bainbridgea00736b2020-01-08 14:33:17 -08001007 ERR_OUT=$(mktemp)
1008 (set -x; curl --fail -o ./$NAME-values.yaml -sSL https://raw.githubusercontent.com/ciena/kind-voltha/$VK_RELEASE/$TYPE-values.yaml >>$LOG 2>$ERR_OUT) >>$LOG 2>&1
1009 if [ $? -ne 0 ]; then
1010 espin - $THEX
1011 echo -e "${RED}${BOLD}${ERROR}ERROR: $NAME-values.yaml${NORMAL}${RED} - $(cat $ERR_OUT)${NORMAL}"
1012 echo "ERROR: $(cat $ERR_OUT)" >>$LOG
1013 rm -rf $ERR_OUT ./$NAME-values.yaml
1014 exit 1
1015 fi
1016 rm -rf $ERR_OUT
Test Userba1e7e72019-07-10 22:27:54 +00001017 espin - $VERIFIED
1018else
1019 espin $VERIFIED
1020fi
David Bainbridgee87067b2019-08-12 22:00:12 +00001021if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001022 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001023fi
Test Userba1e7e72019-07-10 22:27:54 +00001024
David Bainbridge99ac7a22019-08-31 02:26:43 +00001025STIME=$(date +%s)
1026bspin "Verify or download chart specific values files $DOWNLOAD"
1027VALUES_FILES="monkey-values.yaml"
David K. Bainbridgea00736b2020-01-08 14:33:17 -08001028ERR_OUT=$(mktemp)
David Bainbridge99ac7a22019-08-31 02:26:43 +00001029for i in $VALUES_FILES; do
1030 if [ ! -r ./$i ]; then
David K. Bainbridgea00736b2020-01-08 14:33:17 -08001031 (set -x; curl --fail -o ./$i -sSL https://raw.githubusercontent.com/ciena/kind-voltha/$VK_RELEASE/$i >>$LOG 2>$ERR_OUT) >>$LOG 2>&1
1032 if [ $? -ne 0 ]; then
1033 espin $THEX
1034 echo -e "${RED}${BOLD}${ERROR}ERROR: $i${NORMAL}${RED} - $(cat $ERR_OUT)${NORMAL}"
1035 echo "ERROR: $i - $(cat $ERR_OUT)" >>$LOG
1036 rm -rf $ERR_OUT ./$i
1037 exit 1
1038 fi
1039 rm -rf $ERR_OUT
David Bainbridge99ac7a22019-08-31 02:26:43 +00001040 fi
1041done
1042espin $VERIFIED
1043if [ "$WITH_TIMINGS" == "yes" ]; then
1044 printtime $(expr $(date +%s) - $STIME)
1045fi
1046
1047if [ "$WITH_CHAOS" == "yes" ]; then
1048 bspin "Verify or clone kube-monkey helm chart $DOWNLOAD"
1049 if [ -r ./kube-monkey ]; then
1050 espin $VERIFIED
1051 else
1052 espin $NOT_VERIFIED
1053 bspin - "GIT clone kube-monkey"
1054 (set -x; git clone https://github.com/asobti/kube-monkey kube-monkey >>$LOG 2>&1) >>$LOG 2>&1
1055 espin - $VERIFIED
1056 fi
1057fi
1058
Test Userba1e7e72019-07-10 22:27:54 +00001059if [ "$JUST_K8S" == "yes" ]; then
1060 echo "Environment deployed, not deploying VOLTHA artifacts as requested. Good bye."
1061 echo ""
1062 echo "Please issue the following commands in your terminal to ensure that you" | tee -a $LOG
1063 echo "are accessing the correct Kubernetes/Kind cluster as well as have the " | tee -a $LOG
1064 echo "tools required by VOLTHA in your command path. " | tee -a $LOG
1065 echo "" | tee -a $LOG
1066 echo -en $BOLD
1067 if [ $DEPLOY_K8S == "yes" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +00001068 echo "export KUBECONFIG=\"\$(./bin/kind get kubeconfig-path --name=\"voltha-$NAME\")\"" | tee -a $LOG
Test Userba1e7e72019-07-10 22:27:54 +00001069 fi
1070 echo "export PATH=$GOPATH/bin:\$PATH" | tee -a $LOG
1071 echo -en $NORMAL
1072 echo "" | tee -a $LOG
1073 echo "Thank you for choosing kind-voltha for you quick cluster needs." | tee -a $LOG
1074 exit 0
1075fi
1076
David Bainbridgee87067b2019-08-12 22:00:12 +00001077STIME=$(date +%s)
Test Userb5712372019-07-03 21:52:17 +00001078bspin "Verify ETCD Operator $OLD_KEY"
Test User7d866122019-07-09 17:52:35 +00001079if [ $(helm list --deployed --short --namespace voltha "^etcd-operator\$" | wc -l) -ne 1 ]; then
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -07001080 espin $NOT_VERIFIED
David Bainbridge90fd8e32019-08-21 23:32:47 +00001081 helm_install - voltha etcd-operator stable/etcd-operator latest "Install ETCD Operator"
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001082else
1083 espin $VERIFIED
1084fi
Test User01ed0642019-07-03 20:17:06 +00001085EXPECT=$(test "$TYPE" == "minimal" && echo "1" || echo "3")
David Bainbridge4f1b5562019-08-19 04:46:52 +00001086wait_for_pods - "voltha" $EXPECT "includes" -1 "Waiting for ETCD Operator to start" "etcd-operator-.*"
David Bainbridgee87067b2019-08-12 22:00:12 +00001087if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001088 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001089fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001090
David Bainbridgee87067b2019-08-12 22:00:12 +00001091STIME=$(date +%s)
David Bainbridgeb270c202019-07-26 01:44:42 +00001092if [ $WITH_ONOS == "yes" ]; then
1093 bspin "Verify ONOS installed $BIRD"
1094 if [ $(helm list --deployed --short --namespace default "^onos\$" | wc -l) -ne 1 ]; then
1095 espin $NOT_VERIFIED
Andrea Campanella6afcb082019-12-18 16:51:30 -08001096 EXTRA_HELM_FLAGS="$SET_TAG $EXTRA_HELM_FLAGS" helm_install - default onos onf/onos $ONOS_CHART_VERSION "Install ONOS"
David Bainbridgeb270c202019-07-26 01:44:42 +00001097 else
1098 espin $VERIFIED
1099 fi
David Bainbridge4f1b5562019-08-19 04:46:52 +00001100 wait_for_pods - "default" 1 "includes" -1 "Waiting for ONOS to start" "onos-.*"
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -07001101
David Bainbridgeb270c202019-07-26 01:44:42 +00001102 bspin - "Forward ONOS API port $FORWARD"
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -08001103 kill_port_forward onos-ui
1104 port_forward default onos-ui $ONOS_API_PORT 8181
David Bainbridgeb270c202019-07-26 01:44:42 +00001105 espin - $VERIFIED
1106 bspin - "Forward ONOS SSH port $FORWARD"
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -08001107 kill_port_forward onos-ssh
1108 port_forward default onos-ssh $ONOS_SSH_PORT 8101
David Bainbridgeb270c202019-07-26 01:44:42 +00001109 espin - $VERIFIED
David Bainbridged31d6122019-08-13 19:37:59 +00001110 bspin - "Verify or download ONOS configuration support files $DOWNLOAD"
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001111 ONOS_FILES="olt-onos-enableExtraneousRules.json onos-aaa.json \
David Bainbridge90fd8e32019-08-21 23:32:47 +00001112 onos-dhcpl2relay.json onos-kafka.json onos-sadis-sample.json"
David Bainbridged31d6122019-08-13 19:37:59 +00001113 (set -x; mkdir -p ./onos-files >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridgea00736b2020-01-08 14:33:17 -08001114 ERR_OUT=$(mktemp)
David Bainbridge2b19e832019-08-16 02:40:53 +00001115 for i in $ONOS_FILES; do
David Bainbridged31d6122019-08-13 19:37:59 +00001116 if [ ! -r ./onos-files/$i ]; then
David K. Bainbridgea00736b2020-01-08 14:33:17 -08001117 (set -x; curl --fail -o ./onos-files/$i -sSL https://raw.githubusercontent.com/ciena/kind-voltha/$VK_RELEASE/onos-files/$i >>$LOG 2>$ERR_OUT) >>$LOG 2>&1
1118 if [ $? -ne 0 ]; then
1119 espin - $THEX
1120 echo -e "${RED}${BOLD}${ERROR}ERROR: $i${NORMAL}${RED} - $(cat $ERR_OUT)${NORMAL}"
1121 echo "ERROR: $(cat $ERR_OUT)" >>$LOG
1122 rm -rf $ERR_OUT ./onos-files/$i
1123 exit 1
1124 fi
1125 rm -rf $ERR_OUT
David Bainbridged31d6122019-08-13 19:37:59 +00001126 fi
1127 done
Test Userba1e7e72019-07-10 22:27:54 +00001128 espin - $VERIFIED
David Bainbridge27790d62019-08-13 22:43:19 +00001129
1130 if [ $INSTALL_ONOS_APPS == "yes" ]; then
1131 bspin - "Installing custom ONOS applications"
1132 if [ -x onos-files/onos-apps -a $(ls -1 onos-files/onos-apps/*.oar 2>/dev/null | wc -l) -gt 0 ]; then
1133 for OAR in $(ls -1 onos-files/onos-apps/*.oar); do
1134 sspin - "Installing custom ONOS applications - $OAR$CEOL"
David Bainbridge2b19e832019-08-16 02:40:53 +00001135 override_onos_app $OAR
David Bainbridge27790d62019-08-13 22:43:19 +00001136 done
1137 espin - "$VERIFIED Installing custom ONOS applications$CEOL"
1138 else
1139 espin - "$NOT_VERIFIED Installing custom ONOS applications - None Found"
1140 fi
1141 fi
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -07001142
Matteo Scandolo9a77a732020-01-09 14:24:12 -08001143 check_onos_app_active org.opencord.kafka
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001144 push_onos_config "file" "Push ONOS Kafka Configuration" "network/configuration/apps/org.opencord.kafka" "onos-files/onos-kafka.json"
Matteo Scandolo9a77a732020-01-09 14:24:12 -08001145 check_onos_app_active org.opencord.dhcpl2relay
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001146 push_onos_config "file" "Push ONOS DHCP L2 Relay Configuration" "network/configuration/apps/org.opencord.dhcpl2relay" "onos-files/onos-dhcpl2relay.json"
Matteo Scandolo9a77a732020-01-09 14:24:12 -08001147 check_onos_app_active org.opencord.olt
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001148 # FIXME use WITH_DHCP and WITH_EAPOL flags to configre OLT App
Hardik Windlassa7501fb2020-02-17 14:28:20 +00001149 # Default value for "enableEapol" is true in OLT App
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001150 if [ $WITH_EAPOL == "yes" ]; then
1151 push_onos_config "json" "Enable VOLTHA ONOS EAPOL provisioning" "configuration/org.opencord.olt.impl.OltFlowService" '{"enableEapol":true}'
Hardik Windlassa7501fb2020-02-17 14:28:20 +00001152 elif [ $WITH_EAPOL == "no" ]; then
1153 push_onos_config "json" "Disable VOLTHA ONOS EAPOL provisioning" "configuration/org.opencord.olt.impl.OltFlowService" '{"enableEapol":false}'
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001154 fi
Hardik Windlassa7501fb2020-02-17 14:28:20 +00001155 # Default value for "enableDhcpOnProvisioning" is false and for "enableDhcpV4" is true in OLT App
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001156 if [ $WITH_DHCP == "yes" ]; then
1157 push_onos_config "json" "Enable VOLTHA ONOS DHCP provisioning" "configuration/org.opencord.olt.impl.OltFlowService" '{"enableDhcpOnProvisioning":true,"enableDhcpV4":true}'
Hardik Windlassa7501fb2020-02-17 14:28:20 +00001158 elif [ $WITH_DHCP == "no" ]; then
1159 push_onos_config "json" "Disable VOLTHA ONOS DHCP provisioning" "configuration/org.opencord.olt.impl.OltFlowService" '{"enableDhcpOnProvisioning":false,"enableDhcpV4":false}'
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001160 fi
Hardik Windlassa7501fb2020-02-17 14:28:20 +00001161 # Default value for "enableIgmpOnProvisioning" is false in OLT App
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001162 if [ $WITH_IGMP == "yes" ]; then
1163 push_onos_config "json" "Enable VOLTHA ONOS IGMP provisioning" "configuration/org.opencord.olt.impl.OltFlowService" '{"enableIgmpOnProvisioning":true}'
Hardik Windlassa7501fb2020-02-17 14:28:20 +00001164 elif [ $WITH_IGMP == "no" ]; then
1165 push_onos_config "json" "Disable VOLTHA ONOS IGMP provisioning" "configuration/org.opencord.olt.impl.OltFlowService" '{"enableIgmpOnProvisioning":false}'
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001166 fi
1167 push_onos_config "file" "Enabling extraneous rules for ONOS" "configuration/org.onosproject.net.flow.impl.FlowRuleManager" "onos-files/olt-onos-enableExtraneousRules.json"
David Bainbridge2b19e832019-08-16 02:40:53 +00001168 if [ -f onos-files/onos-sadis.json ]; then
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001169 push_onos_config "file" "[optional] Push ONOS SADIS Configuration" "network/configuration/apps/org.opencord.sadis" "onos-files/onos-sadis.json"
David Bainbridge2b19e832019-08-16 02:40:53 +00001170 elif [ "$CONFIG_SADIS" == "yes" ]; then
David Bainbridge90fd8e32019-08-21 23:32:47 +00001171 SADIS_CFG=onos-files/onos-sadis-sample.json
Matteo Scandolo9a77a732020-01-09 14:24:12 -08001172 check_onos_app_active org.opencord.sadis
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001173 push_onos_config "file" "[optional] Push ONOS SADIS Configuration" "network/configuration/apps/org.opencord.sadis" "$SADIS_CFG"
David Bainbridge2b19e832019-08-16 02:40:53 +00001174 fi
Test Userba1e7e72019-07-10 22:27:54 +00001175fi
David Bainbridgee87067b2019-08-12 22:00:12 +00001176if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001177 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001178fi
Test Userba1e7e72019-07-10 22:27:54 +00001179
David Bainbridgee87067b2019-08-12 22:00:12 +00001180STIME=$(date +%s)
Test Userb5712372019-07-03 21:52:17 +00001181bspin "Verify VOLTHA installed $HIGH_VOLTAGE"
Test User7d866122019-07-09 17:52:35 +00001182if [ $(helm list --deployed --short --namespace voltha "^voltha\$" | wc -l) -ne 1 ]; then
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001183 espin $NOT_VERIFIED
David Bainbridge70c0ea82019-11-14 23:25:26 +00001184 if [ "$ONLY_ONE" == "yes" ]; then
1185 EXTRA_HELM_INSTALL_ARGS="--set therecanbeonlyone=true"=
1186 fi
David Bainbridge90fd8e32019-08-21 23:32:47 +00001187 helm_install - voltha voltha $VOLTHA_CHART $VOLTHA_CHART_VERSION "Install VOLTHA Core"
David Bainbridge70c0ea82019-11-14 23:25:26 +00001188 EXTRA_HELM_INSTALL_ARGS=
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001189else
1190 espin $VERIFIED
1191fi
Test Userba1e7e72019-07-10 22:27:54 +00001192
David Bainbridge90fd8e32019-08-21 23:32:47 +00001193VOLTHA="voltha-ofagent-.* \
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001194 ro-core.* \
1195 rw-core.* \
1196 voltha-api-server-.* \
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001197 voltha-etcd-cluster-.* \
1198 voltha-kafka-.* \
1199 voltha-zookeeper-.*"
David Bainbridge70c0ea82019-11-14 23:25:26 +00001200if [ "$ONLY_ONE" == "yes" ]; then
David Bainbridge1ba64f12019-12-18 00:40:13 +00001201 EXPECT=$(test "$TYPE" == "minimal" && echo "5" || echo "7")
David Bainbridge70c0ea82019-11-14 23:25:26 +00001202else
David Bainbridge1ba64f12019-12-18 00:40:13 +00001203 EXPECT=$(test "$TYPE" == "minimal" && echo "8" || echo "10")
David Bainbridge70c0ea82019-11-14 23:25:26 +00001204fi
David Bainbridge4f1b5562019-08-19 04:46:52 +00001205wait_for_pods - "voltha" $EXPECT "includes" -1 "Waiting for VOLTHA Core to start" $VOLTHA
David Bainbridgee87067b2019-08-12 22:00:12 +00001206if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001207 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001208fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001209
David Bainbridge46505fb2019-10-01 21:13:20 +00001210if [ "$WITH_ADAPTERS" == "yes" ]; then
1211 STIME=$(date +%s)
1212 EXPECT=0
1213 echo -e "Verify Adapters $PLUG"
1214 if [ "$WITH_SIM_ADAPTERS" == "yes" ]; then
1215 bspin - "Verify Simulated Adapters installed"
1216 if [ $(helm list --deployed --short --namespace voltha "^sim\$" | wc -l) -ne 1 ]; then
1217 espin - $NOT_VERIFIED
1218 helm_install - voltha sim $VOLTHA_ADAPTER_SIM_CHART $VOLTHA_ADAPTER_SIM_CHART_VERSION "Install Simulated Adapters"
1219 else
1220 espin - $VERIFIED
1221 fi
1222 EXPECT=$(expr $EXPECT + 2)
1223 fi
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -07001224
David Bainbridge46505fb2019-10-01 21:13:20 +00001225 if [ "$WITH_OPEN_ADAPTERS" == "yes" ]; then
1226 bspin - "Verify OpenOLT Adapter installed"
1227 if [ $(helm list --deployed --short --namespace voltha "^open-olt\$" | wc -l) -ne 1 ]; then
1228 espin - $NOT_VERIFIED
1229 helm_install - voltha open-olt $VOLTHA_ADAPTER_OPEN_OLT_CHART $VOLTHA_ADAPTER_OPEN_OLT_CHART_VERSION "Install OpenOLT Adapter"
1230 else
1231 espin - $VERIFIED
1232 fi
1233 bspin - "Verify OpenONU Adapter installed"
1234 if [ $(helm list --deployed --short --namespace voltha "^open-onu\$" | wc -l) -ne 1 ]; then
1235 espin - $NOT_VERIFIED
1236 helm_install - voltha open-onu $VOLTHA_ADAPTER_OPEN_ONU_CHART $VOLTHA_ADAPTER_OPEN_ONU_CHART_VERSION "Install OpenONU Adapter"
1237 else
1238 espin - $VERIFIED
1239 fi
1240 EXPECT=$(expr $EXPECT + 2)
1241 fi
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -07001242
David Bainbridge46505fb2019-10-01 21:13:20 +00001243 ADAPTERS="adapter-.*"
1244 wait_for_pods - "voltha" $EXPECT "includes" -1 "Waiting for adapters to start" $ADAPTERS
1245 if [ "$WITH_TIMINGS" == "yes" ]; then
1246 printtime $(expr $(date +%s) - $STIME)
1247 fi
David Bainbridgee87067b2019-08-12 22:00:12 +00001248fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001249
Test User7d866122019-07-09 17:52:35 +00001250if [ $WITH_BBSIM == "yes" ]; then
David Bainbridgee87067b2019-08-12 22:00:12 +00001251 STIME=$(date +%s)
Test User7d866122019-07-09 17:52:35 +00001252 echo -e "Verify BBSIM $PLUG"
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001253 bspin - "Verify BBSIM Installed"
uottrembb16d3982020-02-28 08:34:36 +01001254 for instance in $(seq 0 $(($NUM_OF_BBSIM-1))); do
1255 if [ $instance -eq 0 ]; then
1256 instance_num=""
1257 else
1258 instance_num=$instance
1259 fi
1260 if [ $(helm list --deployed --short --namespace voltha "^bbsim${instance_num}\$" | wc -l) -ne 1 ]; then
1261 espin - $NOT_VERIFIED
1262 helm_install - voltha bbsim${instance_num} $VOLTHA_BBSIM_CHART $VOLTHA_BBSIM_CHART_VERSION "Install BBSIM${instance_num}"
1263 else
1264 espin - $VERIFIED
1265 fi
1266 done
1267 wait_for_pods - "voltha" $NUM_OF_BBSIM "includes" -1 "Waiting for BBSIM to start" "bbsim*"
David Bainbridgee87067b2019-08-12 22:00:12 +00001268 if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001269 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001270 fi
Test User7d866122019-07-09 17:52:35 +00001271fi
1272
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001273if [ $WITH_RADIUS == "yes" ]; then
David Bainbridgee87067b2019-08-12 22:00:12 +00001274 STIME=$(date +%s)
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001275 echo -e "Verify RADIUS $LOCK"
1276 bspin - "Verify RADIUS Installed"
1277 if [ $(helm list --deployed --short --namespace voltha "^radius\$" | wc -l) -ne 1 ]; then
1278 espin - $NOT_VERIFIED
David Bainbridge90fd8e32019-08-21 23:32:47 +00001279 helm_install - voltha radius onf/freeradius latest "Install RADIUS"
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001280 else
1281 espin - $VERIFIED
1282 fi
David Bainbridge4f1b5562019-08-19 04:46:52 +00001283 wait_for_pods - "voltha" 1 "includes" -1 "Waiting for RADIUS to start" "radius-.*"
David Bainbridgee87067b2019-08-12 22:00:12 +00001284 if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001285 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001286 fi
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001287fi
1288
David Bainbridgee87067b2019-08-12 22:00:12 +00001289STIME=$(date +%s)
Test Userb5712372019-07-03 21:52:17 +00001290bspin - "Forward VOLTHA API port $FORWARD"
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -08001291kill_port_forward voltha-api
1292port_forward voltha voltha-api $VOLTHA_API_PORT 55555
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001293espin - $VERIFIED
David Bainbridgeac7f8072019-08-01 22:15:33 +00001294bspin - "Forward VOLTHA ETCD port $FORWARD"
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -08001295kill_port_forward voltha-etcd-cluster-client
1296port_forward voltha voltha-etcd-cluster-client $VOLTHA_ETCD_PORT 2379
David Bainbridgeac7f8072019-08-01 22:15:33 +00001297espin - $VERIFIED
David Bainbridgee87067b2019-08-12 22:00:12 +00001298if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001299 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001300fi
Test User3d7ad8e2019-07-03 06:15:44 +00001301
David Bainbridgeb270c202019-07-26 01:44:42 +00001302if [ $WITH_ONOS == "yes" -a $WITH_RADIUS == "yes" ]; then
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001303 bspin "Configure ONOS RADIUS Connection $GEAR"
Andy Bavier658ebef2019-11-05 17:22:56 -07001304 (set -x; cat onos-files/onos-aaa.json | sed -e "s/:RADIUS_IP:/$(kubectl -n voltha get service/radius -o jsonpath={.spec.clusterIP})/g" | curl --fail -sSL --user karaf:karaf -X POST http://127.0.0.1:$ONOS_API_PORT/onos/v1/network/configuration/apps/org.opencord.aaa -H Content-type:application/json -d@- >>$LOG 2>&1) >>$LOG 2>&1
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001305 espin $VERIFIED
1306fi
1307
David Bainbridge99ac7a22019-08-31 02:26:43 +00001308if [ "$WITH_CHAOS" == "yes" ]; then
1309 STIME=$(date +%s)
1310 echo -e "Verify kube-monkey $LOCK"
1311 bspin - "Verify kube-monkey Installed"
1312 if [ $(helm list --deployed --short --namespace kube-monkey "^monkey\$" | wc -l) -ne 1 ]; then
1313 espin - $NOT_VERIFIED
1314 helm_install - kube-monkey monkey ./kube-monkey/helm/kubemonkey latest "Install Chaos Monkey"
1315 else
1316 espin - $VERIFIED
1317 fi
1318 wait_for_pods - "kube-monkey" 1 "includes" -1 "Waiting for Chaos to start" "monkey-.*"
1319 if [ "$WITH_TIMINGS" == "yes" ]; then
1320 printtime $(expr $(date +%s) - $STIME)
1321 fi
1322fi
1323
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001324bspin "Create voltctl configuration file"
Test User3d7ad8e2019-07-03 06:15:44 +00001325(set -x; mkdir -p $HOME/.volt >>$LOG 2>&1) >>$LOG 2>&1
David Bainbridge0774b232019-08-02 06:37:19 +00001326(set -x; voltctl -a v2 -s localhost:$VOLTHA_API_PORT config > $HOME/.volt/config-$NAME 2>>$LOG) >>$LOG 2>&1
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001327espin $VERIFIED
Test User08ebbd92019-07-03 17:15:39 +00001328
David Bainbridge0774b232019-08-02 06:37:19 +00001329if [ ! -f "$NAME-env.sh" ]; then
1330 touch $NAME-env.sh
David Bainbridgeb07fdf72019-07-29 22:51:40 +00001331fi
1332
David Bainbridge596f30d2019-07-30 17:07:59 +00001333for O in $ALL_OPTIONS; do
1334 VAL=$(eval echo \$$O)
David Bainbridge0774b232019-08-02 06:37:19 +00001335 if [ ! -z "$VAL" -a $(grep -c "^export $O=" $NAME-env.sh) -eq 0 ]; then
1336 echo "export $O=\"$(eval echo \$$O)\"" >> $NAME-env.sh
David Bainbridgeb07fdf72019-07-29 22:51:40 +00001337 fi
1338done
1339
David Bainbridge0774b232019-08-02 06:37:19 +00001340if [ $DEPLOY_K8S == "yes" -a $(grep -c "^export KUBECONFIG=" $NAME-env.sh) -eq 0 ]; then
1341 echo "export KUBECONFIG=\"$(./bin/kind get kubeconfig-path --name=voltha-$NAME)\"" >> $NAME-env.sh
David Bainbridgeb07fdf72019-07-29 22:51:40 +00001342fi
1343
David Bainbridge0774b232019-08-02 06:37:19 +00001344if [ $(grep -c "^export VOLTCONFIG=" $NAME-env.sh) -eq 0 ]; then
1345 echo "export VOLTCONFIG=\"$HOME/.volt/config-$NAME\"" >> $NAME-env.sh
David Bainbridgeb07fdf72019-07-29 22:51:40 +00001346fi
1347
David Bainbridge0774b232019-08-02 06:37:19 +00001348if [ $(grep -c "^export PATH=" $NAME-env.sh) -eq 0 ]; then
1349 echo "export PATH=\"$GOPATH/bin:\$PATH\"" >> $NAME-env.sh
David Bainbridgeb07fdf72019-07-29 22:51:40 +00001350fi
1351
Test User7d866122019-07-09 17:52:35 +00001352echo ""
Test User08ebbd92019-07-03 17:15:39 +00001353echo "Please issue the following commands in your terminal to ensure that you" | tee -a $LOG
1354echo "are accessing the correct Kubernetes/Kind cluster as well as have the " | tee -a $LOG
1355echo "tools required by VOLTHA in your command path. " | tee -a $LOG
1356echo "" | tee -a $LOG
Test User7d866122019-07-09 17:52:35 +00001357echo -en $BOLD
Test Userba1e7e72019-07-10 22:27:54 +00001358if [ $DEPLOY_K8S == "yes" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +00001359 echo "export KUBECONFIG=\"\$(./bin/kind get kubeconfig-path --name=\"voltha-$NAME\")\"" | tee -a $LOG
Test Userba1e7e72019-07-10 22:27:54 +00001360fi
David Bainbridge0774b232019-08-02 06:37:19 +00001361echo "export VOLTCONFIG=\"$HOME/.volt/config-$NAME\"" | tee -a $LOG
Test Userba1e7e72019-07-10 22:27:54 +00001362echo "export PATH=$GOPATH/bin:\$PATH" | tee -a $LOG
Test User7d866122019-07-09 17:52:35 +00001363echo -en $NORMAL
Test User08ebbd92019-07-03 17:15:39 +00001364echo "" | tee -a $LOG
1365echo "Thank you for choosing kind-voltha for you quick cluster needs." | tee -a $LOG
1366
David Bainbridge712afb82019-08-14 19:55:58 +00001367if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridgef858a022019-08-14 21:25:11 +00001368 echo -e "$CLOCK ${BOLD}TOTAL: $(duration $(expr $(date +%s) - $TOTAL_START_TIME))${NORMAL}"
David Bainbridge712afb82019-08-14 19:55:58 +00001369fi